%define name		mockobjects
%define version		0.09
%define release		8jpp
%define section		free

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	Java MockObjects package
License:	BSD Style
URL:		http://www.mockobjects.com/
Group:		Development/Testing
Vendor:         JPackage Project
Distribution:   JPackage
Source0:	http://www.mockobjects.com/dist/%{name}-%{version}.tar.gz
Patch0:		%{name}-buildjdk.patch
Patch1:		%{name}-ext-httpmethod-abstract.patch
Provides:	%{name}
Requires:	junit
Requires:	/usr/sbin/update-alternatives
BuildRequires:	ant >= 1.5
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	java-devel >= 1.3.0
BuildRequires:	java-devel < 1.4
BuildRequires:	java-devel >= 1.4.0
BuildRequires:	java-devel < 1.5
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The Mock Objects project is a generic unit testing framework whose goal
is to facilitate developing unit tests in the mock object style. The
goal of this project is to provide, a core mock objects framework. This
is a library of code that supports the implementation of mock objects.
It is based around a set of expectation classes for values and
collections. There are also various other classes to make mock objects
easier to write or to use.

%package jdk1.3
Summary:	MockObjects for 1.3.1 JDK
Group:		Development/Testing
Requires:	/usr/sbin/update-alternatives 
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.3.0
Requires:	java-devel < 1.4

%description jdk1.3
MockObjects specific to JDK 1.3.1

%package jdk1.4
Summary:	MockObjects for 1.4 JDK
Group:		Development/Testing
Requires:	/usr/sbin/update-alternatives, java-1.4.1
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%description jdk1.4
MockObjects specific to JDK 1.4.x

%package httpclient
Summary:	MockObjects for Commons HttpClient
Group:		Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	/usr/sbin/update-alternatives
Requires:	jakarta-commons-httpclient

%description httpclient
MockObjects for Jakarta Commons HttpClient

%package alt-httpclient
Summary:        Mockable API for Commons HttpClient
Group:          Development/Testing
Requires:       /usr/sbin/update-alternatives
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-httpclient = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-httpclient

%description alt-httpclient
Alternative API for Jakarta Commons HttpClient to allow for testing

%package alt-jdk1.4
Summary:        Mockable API for JDK 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%description alt-jdk1.4
Alternative API for JDK 1.4 to allow for testing

%package alt-jdk1.3
Summary:        Mockable API for JDK 1.3
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.3 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.3.0
Requires:	java-devel < 1.4

%description alt-jdk1.3
Alternative API for JDK 1.3 to allow for testing

%prep
%setup -q -n %{name}-%{version}
%patch0
%patch1 -p1

%build

# build with empty CLASSPATH
ant -buildfile build.xml -Dbuild.compiler=modern jar-core

#JVM extensions

for vm in 0 1 2; do
    if [ -e %{_jvmdir}/java-1.4.${vm}/bin/javac ]; then
	VM_14=${vm}
    fi
done

JAVA_HOME=%{_jvmdir}/java-1.3.1 ant -buildfile build.xml -Dbuild.compiler=modern jar-jdk
JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern jar-jdk

#Httpclient extensions
CLASSPATH=`build-classpath jakarta-commons-httpclient` ant jar-ext-httpclient


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_javadir}{-1.3.0,-1.3.1,-1.4.0,-1.4.1,-1.4.2}
mkdir -p $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-{,alt-}jdk1.{3,4}

pushd out
install -m 644 %{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
install -m 644 %{name}-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-httpclient-%{version}.jar
install -m 644 alt-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-alt-httpclient-%{version}.jar

# Install JDK Mocks and alternatives
install -m 644 %{name}-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
install -m 644 %{name}-jdk1.3-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.3/%{name}-%{version}.jar
install -m 644 %{name}-alt-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4/%{name}-alt-%{version}.jar
install -m 644 %{name}-alt-jdk1.3-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.3/%{name}-alt-%{version}.jar

popd

pushd $RPM_BUILD_ROOT%{_javadir} 
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.3
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.3
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd


for EXTENSION_VM in 1.3.0 1.3.1 1.4.0 1.4.1 1.4.2; do
   EXTENSION_PREFIX=$(echo $EXTENSION_VM | sed -e 's/1\.\([34]\)\.[0-9]/1.\1/')
   pushd $RPM_BUILD_ROOT%{_javadir}-${EXTENSION_VM}
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-%{version}.jar  .
      ln -sf %{_javadir}-ext/%{name}-alt-jdk${EXTENSION_PREFIX}/%{name}-alt-%{version}.jar .
      for jar in *-%{version}.jar; do
         ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
      done
    popd
done

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.3
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post

%postun

%files
%defattr(0644,root,root,0755)
%doc doc/README
%{_javadir}/%{name}-core*

%files jdk1.3
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.3/%{name}-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.3/%{name}.jar
%{_javadir}-1.3.0/%{name}-%{version}.jar
%{_javadir}-1.3.0/%{name}.jar
%{_javadir}-1.3.1/%{name}-%{version}.jar
%{_javadir}-1.3.1/%{name}.jar

%files jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}.jar
%{_javadir}-1.4.0/%{name}-%{version}.jar
%{_javadir}-1.4.0/%{name}.jar
%{_javadir}-1.4.1/%{name}-%{version}.jar
%{_javadir}-1.4.1/%{name}.jar
%{_javadir}-1.4.2/%{name}-%{version}.jar
%{_javadir}-1.4.2/%{name}.jar

%files httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-httpclient*
 
%files alt-jdk1.3
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-alt-jdk1.3/*
%{_javadir}-1.3.0/%{name}-alt-%{version}.jar
%{_javadir}-1.3.0/%{name}-alt.jar
%{_javadir}-1.3.1/%{name}-alt-%{version}.jar
%{_javadir}-1.3.1/%{name}-alt.jar

%files alt-jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-alt-jdk1.4/*
%{_javadir}-1.4.0/%{name}-alt-%{version}.jar
%{_javadir}-1.4.0/%{name}-alt.jar
%{_javadir}-1.4.1/%{name}-alt-%{version}.jar
%{_javadir}-1.4.1/%{name}-alt.jar
%{_javadir}-1.4.2/%{name}-alt-%{version}.jar
%{_javadir}-1.4.2/%{name}-alt.jar

%files alt-httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-alt-httpclient*

%changelog
* Thu Jun 26 2003 Paul Nasrat <pauln@truemesh.com> 0.09-8jpp
- Re-jigged alt/jvm symlinks to jars rather than dirs

* Tue Jun 24 2003 Paul Nasrat <pauln@truemesh.com> 0.09-7jpp
- Multi jvm symlinks

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-6jpp
- Use java-ext for JDK specific extensions/alternatives

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-5jpp
- Split alternative APIs - as advised by Jeff Martin

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-4jpp
- BuildRequires sdk rather than jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-3jpp
- BuildRequires multiple jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-2jpp
- Broken up into subpackages
- Patch to build jdk-jar (commited upstream)
- Patch to build httpclient (discussed with upstream)

* Wed Mar 05 2003 Jeff Martin <jeff@custommonkey.org> 0.08-1
- first release
